local sliceadmiral = LibStub("AceAddon-3.0"):GetAddon("SliceAdmiral");
local L = LibStub("AceLocale-3.0"):GetLocale("SliceAdmiral", true);
local addon = sliceadmiral:NewModule("ShowTimer");

function addon:OnInitialize()
sliceadmiral.opt.ShowTimer.args = { 
			GrowUp = {name=L["Bars/GrowUp"],type="toggle",order=1,		
				get = function(info) return SAMod.ShowTimer.Options.Barsup; end,
				set = function(info,val) SAMod.ShowTimer.Options.Barsup = val; end
			},
			Sort = {name=L["Bars/Sort"],type="toggle",order=2,			
				get = function(info) return SAMod.ShowTimer.Options.SortBars; end,
				set = function(info,val) SAMod.ShowTimer.Options.SortBars = val; end
			},
			empty = {name="", type="description",order=3,},
			ShowDoT = {name=L["Bars/ShowDoT"],type="toggle",order=4,		
				get = function(info) return SAMod.ShowTimer.Options.ShowDoTDmg; end,
				set = function(info,val) SAMod.ShowTimer.Options.ShowDoTDmg = val; end
			},
			DoTCrit = {name=L["Bars/DoTCrit"],type="toggle",order=5,		
				get = function(info) return SAMod.ShowTimer.Options.DoTCrits; end,
				set = function(info,val) SAMod.ShowTimer.Options.DoTCrits = val; end
			},
			barTex = {name=L["Main/Texture"], type="select",order=6,
				values = SA_Text,
				get = function(info) return SAMod.ShowTimer.Options.BarTexture; end,
				set = function(info,val) SAMod.ShowTimer.Options.BarTexture = val, sliceadmiral:RetextureBars(val, "spells") end, 
			},
			MasterVolume = {name=L["Sound/MasterVolume"],type="toggle",order=7,width="full",		
				get = function(info) return SAMod.Sound.MasterVolume; end,
				set = function(info,val) SAMod.Sound.MasterVolume = val; end
			},
			OutOfCombat = {name=L["Sound/OutOfCombat"],type="toggle",order=8,width="double",		
				get = function(info) return SAMod.Sound.OutOfCombat; end,
				set = function(info,val) SAMod.Sound.OutOfCombat = val; end
			},
			preview = {name=L["Sound/Preview"],type="toggle",order=9,width="full",		
				get = function(info) return SAMod.Sound.Preview; end,
				set = function(info,val) SAMod.Sound.Preview = val; end
			},
		}
	sliceadmiral.opt.ShowTimer.args["SliceAndDice"] = {name=L["SliceNDice"],type="group",order=10,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.SliceAndDice; end,
				set = function(info,val) SAMod.ShowTimer.SliceAndDice = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.SnDTick; end,
				set = function(info,val)
					SAMod.Sound.SnDTick = val;
					sliceadmiral:SA_SoundTest(val);
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.SnDAlert; end,
				set = function(info,val) SAMod.Sound.SnDAlert = val;
				sliceadmiral:SA_SoundTest(val);				
				end
			},
		}
	};
	sliceadmiral.opt.ShowTimer.args["Rupture"] = {name=L["Rupture"],type="group",order=11,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.Rupture; end,
				set = function(info,val) SAMod.ShowTimer.Rupture = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.RuptureTick; end,
				set = function(info,val)
					SAMod.Sound.RuptureTick = val;
					sliceadmiral:SA_SoundTest(val);
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.RuptureAlert; end,
				set = function(info,val) SAMod.Sound.RuptureAlert = val;
				sliceadmiral:SA_SoundTest(val);
				end
			},
		}
	};
	sliceadmiral.opt.ShowTimer.args["Recuperate"] = {name=L["Recuperate"],type="group",order=12,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.Recuperate; end,
				set = function(info,val) SAMod.ShowTimer.Recuperate = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.RecuperateTick; end,
				set = function(info,val)
					SAMod.Sound.RecuperateTick = val;
					sliceadmiral:SA_SoundTest(val);
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.RecuperateAlert; end,
				set = function(info,val) SAMod.Sound.RecuperateAlert = val;
				sliceadmiral:SA_SoundTest(val);
				end
			},
		}
	};
	sliceadmiral.opt.ShowTimer.args["RevealingStrike"] = {name=L["RevealingStrike"],type="group",order=13,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.RevealingStrike; end,
				set = function(info,val) SAMod.ShowTimer.RevealingStrike = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.RevealingStrikeTick; end,
				set = function(info,val)
					SAMod.Sound.RevealingStrikeTick = val;
					sliceadmiral:SA_SoundTest(val);
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.RevealingStrikeAlert; end,
				set = function(info,val) SAMod.Sound.RevealingStrikeAlert = val;
				sliceadmiral:SA_SoundTest(val);
				end
			},
		}
	};
	sliceadmiral.opt.ShowTimer.args["Vendetta"] = {name=L["Vendetta"],type="group",order=14,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.Vendetta; end,
				set = function(info,val) SAMod.ShowTimer.Vendetta = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.VendettaTick; end,
				set = function(info,val)
					SAMod.Sound.VendettaTick = val;
					sliceadmiral:SA_SoundTest(val);
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.VendettaAlert; end,
				set = function(info,val) SAMod.Sound.VendettaAlert = val;
				sliceadmiral:SA_SoundTest(val);
				end
			},
		}
	};
	sliceadmiral.opt.ShowTimer.args["FindWeaknes"] = {name=L["FindWeaknes"],type="group",order=15,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.FindWeaknes; end,
				set = function(info,val) SAMod.ShowTimer.FindWeaknes = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.FindWeaknesTick; end,
				set = function(info,val)
					SAMod.Sound.FindWeaknesTick = val;
					sliceadmiral:SA_SoundTest(val);
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.FindWeaknesAlert; end,
				set = function(info,val) SAMod.Sound.FindWeaknesAlert = val;
				sliceadmiral:SA_SoundTest(val);
				end
			},
		}
	};
	sliceadmiral.opt.ShowTimer.args["Hemorrhage"] = {name=L["Hemorrhage"],type="group",order=16,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.Hemorrhage; end,
				set = function(info,val) SAMod.ShowTimer.Hemorrhage = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageTick; end,
				set = function(info,val)
					SAMod.Sound.HemorrhageTick = val;
					sliceadmiral:SA_SoundTest(val);
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageAlert; end,
				set = function(info,val) SAMod.Sound.HemorrhageAlert = val;
				sliceadmiral:SA_SoundTest(val);
				end
			},
		}
	};
	sliceadmiral.opt.ShowTimer.args["Garrote"] = {name=L["Garrote"],type="group",order=17,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.Garrote; end,
				set = function(info,val) SAMod.ShowTimer.Garrote = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageTick; end,
				set = function(info,val)
					SAMod.Sound.HemorrhageTick = val;
					sliceadmiral:SA_SoundTest(val);
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageAlert; end,
				set = function(info,val) SAMod.Sound.HemorrhageAlert = val;
				sliceadmiral:SA_SoundTest(val);
				end
			},
		}
	};
	sliceadmiral.opt.ShowTimer.args["BurstOfSpeed"] = {name=L["BurstOfSpeed"],type="group",order=18,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.BurstOfSpeed; end,
				set = function(info,val) SAMod.ShowTimer.BurstOfSpeed = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageTick; end,
				set = function(info,val)
					SAMod.Sound.HemorrhageTick = val; 
					sliceadmiral:SA_SoundTest(val);	
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageAlert; end,
				set = function(info,val) SAMod.Sound.HemorrhageAlert = val;
				sliceadmiral:SA_SoundTest(val);
				end
			},
		}
	};
	sliceadmiral.opt.ShowTimer.args["Envenom"] = {name=L["Envenom"],type="group",order=19,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.Envenom; end,
				set = function(info,val) SAMod.ShowTimer.Envenom = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageTick; end,
				set = function(info,val)
					SAMod.Sound.HemorrhageTick = val;
					sliceadmiral:SA_SoundTest(val);
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageAlert; end,
				set = function(info,val) SAMod.Sound.HemorrhageAlert = val;
				sliceadmiral:SA_SoundTest(val);
				end
			},
		}
	};
	sliceadmiral.opt.ShowTimer.args["Feint"] = {name=L["Feint"],type="group",order=20,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.Feint; end,
				set = function(info,val) SAMod.ShowTimer.Feint = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageTick; end,
				set = function(info,val)
					SAMod.Sound.HemorrhageTick = val;
					sliceadmiral:SA_SoundTest(val);
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageAlert; end,
				set = function(info,val) SAMod.Sound.HemorrhageAlert = val;
				sliceadmiral:SA_SoundTest(val);
				end
			},
		}
	};
	sliceadmiral.opt.ShowTimer.args["DeadlyPoison"] = {name=L["DeadlyPoison"],type="group",order=21,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.DeadlyPoison; end,
				set = function(info,val) SAMod.ShowTimer.DeadlyPoison = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageTick; end,
				set = function(info,val)
					SAMod.Sound.HemorrhageTick = val;
					sliceadmiral:SA_SoundTest(val);
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageAlert; end,
				set = function(info,val) SAMod.Sound.HemorrhageAlert = val;
				sliceadmiral:SA_SoundTest(val);
				end
			},
		}
	};
	sliceadmiral.opt.ShowTimer.args["BanditsGuile"] = {name=L["BanditsGuile"],type="group",order=22,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.BanditsGuile; end,
				set = function(info,val) SAMod.ShowTimer.BanditsGuile = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageTick; end,
				set = function(info,val)
					SAMod.Sound.HemorrhageTick = val;
					sliceadmiral:SA_SoundTest(val);
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageAlert; end,
				set = function(info,val) SAMod.Sound.HemorrhageAlert = val;
				sliceadmiral:SA_SoundTest(val);
				end
			},
		}
	};
	sliceadmiral.opt.ShowTimer.args["InternalBleeding"] = {name=L["InternalBleeding"],type="group",order=23,
		args = {
			enable = {name=L["ShowBar"],type="toggle", order=1,
				get = function(info) return SAMod.ShowTimer.InternalBleeding; end,
				set = function(info,val) SAMod.ShowTimer.InternalBleeding = val; end
			},			
			bar1 = {name=L["SoundSettings"],type="header",order=3},		
			tick = {name=L["TickSound"],type="select",order=12,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageTick; end,
				set = function(info,val)
					SAMod.Sound.HemorrhageTick = val;
					sliceadmiral:SA_SoundTest(val);
				end
			},
			alert = {name=L["AlertSound"],type="select",order=13,disabled=true,
				values = SA_ASounds,
				get = function(info) return SAMod.Sound.HemorrhageAlert; end,
				set = function(info,val) SAMod.Sound.HemorrhageAlert = val;
				sliceadmiral:SA_SoundTest(val);
				end
			},
		}
	};
	
end