-- Author      : Haghala
-- Create Date : 13/10/2014
local addon = LibStub("AceAddon-3.0"):NewAddon("SliceAdmiral","AceConsole-3.0","AceEvent-3.0");
local AceConfig = LibStub("AceConfig-3.0");
local AceConfigDialog = LibStub("AceConfigDialog-3.0");
local L = LibStub("AceLocale-3.0"):GetLocale("SliceAdmiral", true)
local S = LibStub("LibSmoothStatusBar-1.0")
SliceAdmiralVer = GetAddOnMetadata("SliceAdmiral", "Version")
----------------------------------------------------------------------------------------------------

addon.opt = {
	Main = {name = "SliceAdmiral", type = "group", args = {}};
	ShowTimer = {name = "Timer Bars", type = "group", args = {}};
	Combo = {name = "Combo Points and Stats", type = "group", args = {}};
	Energy = {name = "Energy Bar", type = "group", args = {}};
	Sound = {name = "Sound Effects", type = "group", args = {}};	
}

SADefault = {
	data = {
		Version = SliceAdmiralVer,
		lastSort = 0,
		maxSortableBars = 9,
		sortPeriod = 0.5,
		tNow = 0,
		UpdateInterval = 0.05,
		TimeSinceLastUpdate = 0,
		numStats = 3,
	},
	Modules = {
		Main = {
			IsLocked = false,
			PadLatency = true,
			Scale = 130,
			Width = 130,
			BarMargin = 3,
			Fade = 75,
			BarTexture = "Interface\\AddOns\\SliceAdmiral\\Images\\LiteStep.tga",
		},
		ShowTimer = {
			Options = {
				Barsup = true,
				SortBars = true,
				ShowDoTDmg = true,
				DoTCrits = true,
				BarTexture = "Interface\\AddOns\\SliceAdmiral\\Images\\Smooth.tga",
			},
			SliceAndDice = true,
			Rupture = true,
			Recuperate = true,
			Hemorrhage = true,
			FindWeaknes = true,
			DeadlyPoison = true,
			Envenom = true,
			Vendetta = true,
			RevealingStrike = true,
			Feint = true,
			BanditsGuile = true,			
			BurstOfSpeed = true,
			Garrote = true,
			InternalBleeding = false,
		},
		Combo = {			
			PointShow = true,
			AnticipationShow = true,
			ShowStatBar = true,
			HilightBuffed = false,
			Show4thStat = false,
			CPColor = {r=1.0,g=0.86,b=0.1,a=1.0},			
			AnColor = {r=0.1,g=0.86,b=1.0,a=1.0},
		},
		Energy  = {
			ShowEnergy = false,
			ShowComboText = true,
			Energy1 = 25,
			Energy2 = 40,
			BarTexture = "Interface\\AddOns\\SliceAdmiral\\Images\\Runes.tga",
			EnergySound1 = "",
			EnergySound2 = "",
			EnergyTrans = 75,
			Color = { r=1.0, g=0.96, b=0.41, a=1.0}
		},
		Sound = {
			SnDTick = "Interface\\AddOns\\SliceAdmiral\\Audio\\tambourine.ogg",
			SnDAlert = "Interface\\AddOns\\SliceAdmiral\\Audio\\Old Trumpet A 01.ogg",
			RecuperateAlert = "Interface\\AddOns\\SliceAdmiral\\Audio\\tambourine.ogg",
			RecuperateTick = "",
			RuptureTick = "Interface\\AddOns\\SliceAdmiral\\Audio\\shaker.ogg",
			RuptureAlert = "Interface\\AddOns\\SliceAdmiral\\Audio\\6OP00084.ogg",
			FindWeaknesTick = "Interface\\AddOns\\SliceAdmiral\\Audio\\pingit.ogg",  
			FindWeaknesAlert = "Interface\\AddOns\\SliceAdmiral\\Audio\\drumrattle.ogg",
			VendettaTick = "Interface\\AddOns\\SliceAdmiral\\Audio\\pingit.ogg",  
			VendettaAlert = "",
			RevealingStrikeAlert = "Interface\\AddOns\\SliceAdmiral\\Audio\\6OP00084.ogg",
			RevealingStrikeTick = "Interface\\AddOns\\SliceAdmiral\\Audio\\shaker.ogg",
			HemorrhageTick = "Interface\\AddOns\\SliceAdmiral\\Audio\\pingit.ogg",
			HemorrhageAlert = "",
			MasterVolume = false,
			OutOfCombat = false,
			Preview = true,
			none = "none",
		},
	},  
}

SADefaults = {char = SADefault, realm = SADefault, profile = SADefault}
SAGlobals = {Version = SliceAdmiralVer}

SA_Data = {
	lastSort = 0,	 -- Last time bars were sorted
	maxSortableBars = 10, -- How many sortable non-DP/Envenom timer type bars do we have?
	sortPeriod = 0.5, -- Only sort bars every sortPeriod seconds
	tNow = 0,
	UpdateInterval = 0.05,
	TimeSinceLastUpdate = 0,
	BARS = { --TEH BARS
		["CP"] = {
			["obj"] = 0
		},
		[SC_SPELL_RECUP] = {
			["obj"] = 0,
			["Expires"] = 0,		-- Actual time left to expire in seconds
			["AlertPending"] = 0, 
		},
		[SC_SPELL_SND] = {
			["obj"] = 0,
			["Expires"] = 0,
			["AlertPending"] = 0, 
		},
		[SC_SPELL_DP] = {
			["obj"] = 0,
			["Expires"] = 0, 
		},
		[SC_SPELL_RUP] = {
			["obj"] = 0,
			["Expires"] = 0, 
			["AlertPending"] = 0,
		},
		[SC_SPELL_INTERNAL] = {
			["obj"] = 0,
			["Expires"] = 0, 			
		},
		[SC_SPELL_GARROTE] = {
			["obj"] = 0,
			["Expires"] = 0, 
		},
		[SC_SPELL_BURST_SPEED] = {
			["obj"] = 0,
			["Expires"] = 0, 
		},
		[SC_SPELL_VEND] = {
			["obj"] = 0,
			["Expires"] = 0, 
			["AlertPending"] = 0,
		},
		[SC_SPELL_FW] = {
			["obj"] = 0,
			["Expires"] = 0, 
			["AlertPending"] = 0,
		},
		[SC_SPELL_ENV] = {
			["obj"] = 0,
			["Expires"] = 0, 
		},
		[SC_SPELL_REVEAL] = {
			["obj"] = 0,
			["Expires"] = 0, 
			["AlertPending"] = 0,
		},
		[SC_SPELL_HEMO] = {
			["obj"] = 0,
			["Expires"] = 0,
		},
		[SC_SPELL_FEINT] = {
			["obj"] = 0,
			["Expires"] = 0,	
		},
		[SC_SPELL_BAND1] = {
			["obj"] = 0,
			["Expires"] = 0, 
		},
		[SC_SPELL_BAND2] = {
			["obj"] = 0,
			["Expires"] = 0, 
		},
		[SC_SPELL_BAND3] = {
			["obj"] = 0,
			["Expires"] = 0, 
		},
		["Stat"] = {
			["obj"] = 0,
		},
	}
};

local scaleUI = 0
local widthUI = 0

local UnitAffectingCombat = UnitAffectingCombat

function addon:SA_SetScale(NewScale)
  if (NewScale >= 50) then
    SA:SetScale ( NewScale / 100 );
    VTimerEnergy:SetScale ( NewScale / 100 );	
	for k,v in pairs(SA_Data.BARS) do
		SA_Data.BARS[k]["obj"]:SetScale(NewScale/100);
	end
  end
end

function addon:SA_SetWidth(w)
  if (w >= 25) then
    VTimerEnergy:SetWidth(w);
	for k,v in pairs(SA_Data.BARS) do
		SA_Data.BARS[k]["obj"]:SetWidth(w);
	end	
	if SAMod.Energy.ShowEnergy then
		VTimerEnergy:Show();
		local lUnitManaMax = UnitManaMax("player")
		if (lUnitManaMax == 0) then
			lUnitManaMax = 100;
		end
		SA_Spark1:SetPoint("TOPLEFT", VTimerEnergy, "TOPLEFT", (SAMod.Energy.Energy1 / lUnitManaMax * w), 0);
		SA_Spark2:SetPoint("TOPLEFT", VTimerEnergy, "TOPLEFT", (SAMod.Energy.Energy2 / lUnitManaMax * w), 0);
	else
		VTimerEnergy:Hide();
	end
    addon:SA_UpdateCPWidths();
    addon:SA_UpdateStatWidths();
	
  end
end

function addon:RetextureBars(texture, object) 
	if object == "Energy" then
		VTimerEnergy:SetStatusBarTexture(texture);
	end
	if object == "spells" then
		for k,v in pairs(SA_Data.BARS) do
			if not (k == "CP" or k == "Stat") then
				SA_Data.BARS[k]["obj"]:SetStatusBarTexture(texture);			
			end	
		end
	end
	if object == "stats" then
		for k,v in pairs(SA_Data.BARS) do
			if k == "CP" or k == "Stat" then
				SA_Data.BARS[k]["obj"].bg:SetTexture(texture);				
			end	
		end
		for i = 1, 5 do
			SA_Data.BARS["CP"]["obj"].combos[i].bg:SetTexture(texture);
		end
	end	
end

function addon:SA_BarTexture(object)
	if object == "Energy" then
		return SAMod.Energy.BarTexture
	elseif object == "stats" then
		return SAMod.Main.BarTexture
	elseif object == "spells" then
		return SAMod.ShowTimer.Options.BarTexture
	else
		return SAMod.Main.BarTexture ;
	end
end

function addon:SA_SoundTest(name)
	if not SAMod.Sound.Preview then return end
	 if SAMod.Sound.MasterVolume then
		PlaySoundFile(name, "Master" );
	 else
		PlaySoundFile(name);
	 end	 
end

function addon:SA_Sound(saved)
	--print(saved)	
	if not UnitAffectingCombat("player") and not SAMod.Sound.OutOfCombat then return end
	if SAMod.Sound.MasterVolume then
		PlaySoundFile(saved, "Master" );
	else
		PlaySoundFile(saved);
		--PlaySoundFile( SA_ASounds[ SAMod.Sound[saved] ] );
	end	
end

function addon:SA_ChangeAnchor()
 local LastAnchor = VTimerEnergy;
 local offSetSize = SAMod.Main.BarMargin; -- other good values, -1, -2
 local GuileAnchor = LastAnchor
 local opt = SAMod.ShowTimer.Options

 -- Stat bar goes first, because it's fucking awesome like that
 if SAMod.Combo.ShowStatBar then 
	SA_Data.BARS["Stat"]["obj"]:ClearAllPoints();
	SA_Data.BARS["Stat"]["obj"]:SetPoint("BOTTOMLEFT", LastAnchor, "TOPLEFT", 0, offSetSize); 
 end

 --anchor CPs on stat bar if energy bar is hidden.
 if  not SAMod.Energy.ShowEnergy then
	LastAnchor = SA_Data.BARS["Stat"]["obj"];
 end

 -- CP Bar --
 SA_Data.BARS["CP"]["obj"]:ClearAllPoints(); --so it can move
 SA_Data.BARS["CP"]["obj"]:SetPoint("TOPLEFT", LastAnchor, "BOTTOMLEFT", 0, -1 * offSetSize); --CP bar on bottom of Stat Bar

 LastAnchor = SA_Data.BARS["Stat"]["obj"]; --timer bars grow off top of stat bar by default
 if opt.Barsup then
	if SAMod.Combo.ShowStatBar then
		LastAnchor = SA_Data.BARS["Stat"]["obj"];
	else
		if SAMod.Energy.ShowEnergy then
			LastAnchor = VTimerEnergy;
			
		else
			LastAnchor = SA_Data.BARS["CP"]["obj"];
		end
	end
 else
	 if SAMod.Combo.PointShow then
		LastAnchor = SA_Data.BARS["CP"]["obj"];
	 else
		 if SAMod.Energy.ShowEnergy then
		 LastAnchor = VTimerEnergy;
			
		 else
			LastAnchor = SA_Data.BARS["Stat"]["obj"];
		 end
	 end
 end
 for i = 1, SA_Data.maxSortableBars do 
	 if (SA_Data.BARORDER[i]["Expires"] > 0) then
		SA_Data.BARORDER[i]["obj"]:ClearAllPoints();
		if opt.Barsup then
			SA_Data.BARORDER[i]["obj"]:SetPoint("BOTTOMLEFT", LastAnchor, "TOPLEFT", 0, offSetSize); --bar on top
		else
			SA_Data.BARORDER[i]["obj"]:SetPoint("TOPLEFT", LastAnchor, "BOTTOMLEFT", 0, -1 * offSetSize);
		end
		LastAnchor = SA_Data.BARORDER[i]["obj"];
	 end
 end --end loop

 -- Deadly Poison -- DP always on the outside since it's auto-refreshed for the rogue
 if (SA_Data.BARS[SC_SPELL_DP]["Expires"] ~= 0) then
	SA_Data.BARS[SC_SPELL_DP]["obj"]:ClearAllPoints();
	if (opt.Barsup) then
		SA_Data.BARS[SC_SPELL_DP]["obj"]:SetPoint("BOTTOMLEFT", LastAnchor, "TOPLEFT", 0, offSetSize);
	else
		SA_Data.BARS[SC_SPELL_DP]["obj"]:SetPoint("TOPLEFT", LastAnchor, "BOTTOMLEFT", 0, -1 * offSetSize);
	end
	LastAnchor = SA_Data.BARS[SC_SPELL_DP]["obj"];
 end

 -- Envenom -- Envenom to finish this shiznit out.
 if (SA_Data.BARS[SC_SPELL_ENV]["Expires"] ~= 0) then
	SA_Data.BARS[SC_SPELL_ENV]["obj"]:ClearAllPoints();
	if (opt.Barsup) then
		SA_Data.BARS[SC_SPELL_ENV]["obj"]:SetPoint("BOTTOMLEFT", LastAnchor, "TOPLEFT", 0, offSetSize);
	else
		SA_Data.BARS[SC_SPELL_ENV]["obj"]:SetPoint("TOPLEFT", LastAnchor, "BOTTOMLEFT", 0, -1 * offSetSize);
	end
	LastAnchor = SA_Data.BARS[SC_SPELL_ENV]["obj"];
 end
 
 -- Feint 
 if (SA_Data.BARS[SC_SPELL_FEINT]["Expires"] ~= 0) then
	SA_Data.BARS[SC_SPELL_FEINT]["obj"]:ClearAllPoints();
	if (opt.Barsup) then
		SA_Data.BARS[SC_SPELL_FEINT]["obj"]:SetPoint("BOTTOMLEFT", LastAnchor, "TOPLEFT", 0, offSetSize);
	else
		SA_Data.BARS[SC_SPELL_FEINT]["obj"]:SetPoint("TOPLEFT", LastAnchor, "BOTTOMLEFT", 0, -1 * offSetSize);
	end
	LastAnchor = SA_Data.BARS[SC_SPELL_FEINT]["obj"];
 end
 
 -- Bandits Guile
 if (SA_Data.BARS[SC_SPELL_BAND1]["Expire"] ~= 0)  then
	SA_Data.BARS[SC_SPELL_BAND1]["obj"]:ClearAllPoints();	
	if (opt.Barsup) then
		SA_Data.BARS[SC_SPELL_BAND1]["obj"]:SetPoint("BOTTOMLEFT", LastAnchor, "TOPLEFT", 0, offSetSize);
	else
		SA_Data.BARS[SC_SPELL_BAND1]["obj"]:SetPoint("TOPLEFT", LastAnchor, "BOTTOMLEFT", 0, -1 * offSetSize);
	end
	GuileAnchor = LastAnchor
	LastAnchor = SA_Data.BARS[SC_SPELL_BAND1]["obj"];	
 end 
 if (SA_Data.BARS[SC_SPELL_BAND2]["Expire"] ~= 0)  then	
	SA_Data.BARS[SC_SPELL_BAND2]["obj"]:ClearAllPoints();	
	if (opt.Barsup) then
		SA_Data.BARS[SC_SPELL_BAND2]["obj"]:SetPoint("BOTTOMLEFT", GuileAnchor, "TOPLEFT", 0, offSetSize);
	else
		SA_Data.BARS[SC_SPELL_BAND2]["obj"]:SetPoint("TOPLEFT", GuileAnchor, "BOTTOMLEFT", 0, -1 * offSetSize);
	end
	LastAnchor = SA_Data.BARS[SC_SPELL_BAND2]["obj"];
 end 
 if (SA_Data.BARS[SC_SPELL_BAND3]["Expire"] ~= 0) then	
	SA_Data.BARS[SC_SPELL_BAND3]["obj"]:ClearAllPoints();
	if (opt.Barsup) then
		SA_Data.BARS[SC_SPELL_BAND3]["obj"]:SetPoint("BOTTOMLEFT", GuileAnchor, "TOPLEFT", 0, offSetSize);
	else
		SA_Data.BARS[SC_SPELL_BAND3]["obj"]:SetPoint("TOPLEFT", GuileAnchor, "BOTTOMLEFT", 0, -1 * offSetSize);
	end
	LastAnchor = SA_Data.BARS[SC_SPELL_BAND3]["obj"];
 end 
end

function addon:MB_SortBarsByTime(startIndex)
--[[ 
 Dumb ass sort. Simple shuffle of the lower bars to higher if
 they are refreshed. It will only run once every SA_Data.sortPeriod
 seconds, max. Also, we only call this if BARORDER contains a
 non-zero value for expiration. AND we start at the index we
 found the non-zero value at (because we know that the bars above
 that have 0 and we don't need to sort them).
 Also, we only call SA_ChangeAnchor() if something has changed to be
 a little lighter weight.
]]
	if ((SA_Data.tNow - SA_Data.lastSort) >= SA_Data.sortPeriod) then 
		table.sort(SA_Data.BARORDER, function(a,b) return a["Expires"] < b["Expires"] end)
		SA_Data.lastSort = SA_Data.tNow;	
		addon:SA_ChangeAnchor();
	end
end

function addon:PLAYER_ENTERING_WORLD(...)
	addon:SA_TestTarget();	
	VTimerEnergy:SetScript("OnHide", addon.SA_ChangeAnchor)
	VTimerEnergy:SetScript("OnShow", addon.SA_ChangeAnchor)
end

function addon:PLAYER_TARGET_CHANGED(...)	
	addon:SA_TestTarget();
end

function addon:PLAYER_REGEN_DISABLED(...) --lose combat
	UIFrameFadeIn(SA, 0.4, SA:GetAlpha(), 1.0);
end

function addon:PLAYER_REGEN_ENABLED(...) --exit combat
	UIFrameFadeOut(SA, 0.4, SA:GetAlpha(), SAMod.Main.Fade/100)
end

function addon:UNIT_COMBO_POINTS(...)
	addon:SA_SetComboPts();
end

function addon:UNIT_AURA(event, ...)	
	if ... == "player" then		
		addon:SA_SetComboPts();
	end
end

function addon:COMBAT_LOG_EVENT_UNFILTERED(event, ...)	
	local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName = ...;	
	if (type == "SPELL_AURA_REFRESH" or type == "SPELL_AURA_APPLIED" or type == "SPELL_AURA_REMOVED" or type == "SPELL_AURA_APPLIED_DOSE" or type == "SPELL_PERIODIC_AURA_REMOVED" or type == "SPELL_PERIODIC_AURA_APPLIED" or type == "SPELL_PERIODIC_AURA_APPLIED_DOSE" or type == "SPELL_PERIODIC_AURA_REFRESH") then
		local spellId, spellName, spellSchool = select(12, ...);
		local isMySpell;		
		-- print ("spellId = " .. spellId .. " (" .. spellName .. ")");
		-- spellName = GetSpellInfo(spellId);
		-- print("SourceName: " .. sourceName);
		isMySpell = (sourceName == UnitName("player")); 
		if (destName == UnitName("player")) then
			--SLICE N DICE EVENT --
			if (spellId == SC_SPELL_SND_ID and SAMod.ShowTimer.SliceAndDice) then
				if (type == "SPELL_AURA_REMOVED") then					
					addon:SA_Sound(SAMod.Sound.SnDAlert);								
					SA_Data.BARS[SC_SPELL_SND]["Expires"] = 0;				
					SA_Data.BARS[SC_SPELL_SND]["obj"]:Hide();				
				else
					local name, rank, icon, count, debuffType, duration, expirationTime = UnitAura("player", SC_SPELL_SND);					
					SA_Data.BARS[SC_SPELL_SND]["obj"]:Show();					
					SA_Data.BARS[SC_SPELL_SND]["Expires"] = addon:CalcExpireTime(expirationTime);				
				end
				addon:SA_ChangeAnchor();
			end
			-- Bandits Guile --
			if (spellId == SC_SPELL_BAND1_ID and SAMod.ShowTimer.BanditsGuile) then
				if (type == "SPELL_AURA_REMOVED") then									
					SA_Data.BARS[SC_SPELL_BAND1]["Expires"] = 0;				
					SA_Data.BARS[SC_SPELL_BAND1]["obj"]:Hide();				
				else
					local name, rank, icon, count, debuffType, duration, expirationTime = UnitAura("player", SC_SPELL_BAND1);					
					SA_Data.BARS[SC_SPELL_BAND1]["obj"]:Show();					
					SA_Data.BARS[SC_SPELL_BAND1]["Expires"] = addon:CalcExpireTime(expirationTime);						
				end
				addon:SA_ChangeAnchor();
			end
			if (spellId == SC_SPELL_BAND2_ID and SAMod.ShowTimer.BanditsGuile) then
				if (type == "SPELL_AURA_REMOVED") then								
					SA_Data.BARS[SC_SPELL_BAND2]["Expires"] = 0;				
					SA_Data.BARS[SC_SPELL_BAND2]["obj"]:Hide();				
				else
					local name, rank, icon, count, debuffType, duration, expirationTime = UnitAura("player", SC_SPELL_BAND2);
					SA_Data.BARS[SC_SPELL_BAND2]["obj"]:Show();					
					SA_Data.BARS[SC_SPELL_BAND2]["Expires"] = addon:CalcExpireTime(expirationTime);						
				end
				addon:SA_ChangeAnchor();
			end
			if (spellId == SC_SPELL_BAND3_ID and SAMod.ShowTimer.BanditsGuile) then
				if (type == "SPELL_AURA_REMOVED") then								
					SA_Data.BARS[SC_SPELL_BAND3]["Expires"] = 0;				
					SA_Data.BARS[SC_SPELL_BAND3]["obj"]:Hide();				
				else
					local name, rank, icon, count, debuffType, duration, expirationTime = UnitAura("player", SC_SPELL_BAND3);					
					SA_Data.BARS[SC_SPELL_BAND3]["obj"]:Show();					
					SA_Data.BARS[SC_SPELL_BAND3]["Expires"] = addon:CalcExpireTime(expirationTime);									
				end
				addon:SA_ChangeAnchor();
			end
			-- RECUPERATE EVENT --
			if (spellId == SC_SPELL_RECUP_ID and SAMod.ShowTimer.Recuperate) then
				 if (type == "SPELL_AURA_REMOVED") then					
					addon:SA_Sound(SAMod.Sound.RecuperateAlert);					
					SA_Data.BARS[SC_SPELL_RECUP]["Expires"] = 0;
					SA_Data.BARS[SC_SPELL_RECUP]["obj"]:Hide();
				 else
					local name, rank, icon, count, debuffType, duration, expirationTime = UnitAura("player", SC_SPELL_RECUP);								
					SA_Data.BARS[SC_SPELL_RECUP]["Expires"] = addon:CalcExpireTime(expirationTime);
					SA_Data.BARS[SC_SPELL_RECUP]["obj"]:Show();			
				 end
				 addon:SA_ChangeAnchor();
			end
			-- ENVENOM EVENT --
			if (spellId == SC_SPELL_ENV_ID and SAMod.ShowTimer.Envenom) then
				 if (type == "SPELL_AURA_REMOVED") then								
					SA_Data.BARS[SC_SPELL_ENV]["Expires"] = 0;			
					SA_Data.BARS[SC_SPELL_ENV]["obj"]:Hide();
				 else
					local name, rank, icon, count, debuffType, duration, expirationTime = UnitAura("player", SC_SPELL_ENV);								
					SA_Data.BARS[SC_SPELL_ENV]["Expires"] = addon:CalcExpireTime(expirationTime);
					SA_Data.BARS[SC_SPELL_ENV]["obj"]:Show();
				 end
				 addon:SA_ChangeAnchor();
			end
			-- Anticipation event --
			if (spellId == SC_SPELL_ANTICI_ID and SAMod.Combo.PointShow and type == "SPELL_AURA_REMOVED") then		
				addon:SA_SetComboPts();
			end
			-- Feint --
			if (spellId == SC_SPELL_FEINT_ID and SAMod.ShowTimer.Feint) then
				if (type == "SPELL_AURA_REMOVED") then					
					SA_Data.BARS[SC_SPELL_FEINT]["Expires"] = 0;				
					SA_Data.BARS[SC_SPELL_FEINT]["obj"]:Hide();				
				else
					local name, rank, icon, count, debuffType, duration, expirationTime = UnitAura("player", SC_SPELL_FEINT);
					SA_Data.BARS[SC_SPELL_FEINT]["obj"]:Show();					
					SA_Data.BARS[SC_SPELL_FEINT]["Expires"] = addon:CalcExpireTime(expirationTime);				
				end
				addon:SA_ChangeAnchor();
			end
			-- Burst of Speed--
			if (spellId == SC_SPELL_BURST_SPEED_ID and SAMod.ShowTimer.BurstOfSpeed) then
				if (type == "SPELL_AURA_REMOVED") then					
					SA_Data.BARS[SC_SPELL_BURST_SPEED]["Expires"] = 0;				
					SA_Data.BARS[SC_SPELL_BURST_SPEED]["obj"]:Hide();				
				else
					local name, rank, icon, count, debuffType, duration, expirationTime = UnitAura("player", SC_SPELL_BURST_SPEED);
					SA_Data.BARS[SC_SPELL_BURST_SPEED]["obj"]:Show();					
					SA_Data.BARS[SC_SPELL_BURST_SPEED]["Expires"] = addon:CalcExpireTime(expirationTime);				
				end
				addon:SA_ChangeAnchor();
			end
		else
			if (destName == GetUnitName("target",true)) then
				 -- DEADLY POISON EVENT --		 
				 if (isMySpell and spellId == SC_SPELL_DP_ID and SAMod.ShowTimer.DeadlyPoison) then
					if (type == "SPELL_AURA_REMOVED") then						
						SA_Data.BARS[SC_SPELL_DP]["Expires"] = 0;
						SA_Data.BARS[SC_SPELL_DP]["obj"]:Hide();
					else
						local name, rank, icon, count, debuffType, duration, expirationTime = UnitDebuff("target", SC_SPELL_DP, nil, "PLAYER");						
						SA_Data.BARS[SC_SPELL_DP]["Expires"] = addon:CalcExpireTime(expirationTime);			
						SA_Data.BARS[SC_SPELL_DP]["obj"]:Show();
					end
					addon:SA_ChangeAnchor();
				 end
				-- RUPTURE EVENT --
				if (isMySpell and spellId == SC_SPELL_RUP_ID and SAMod.ShowTimer.Rupture) then			
					if (type == "SPELL_AURA_REMOVED") then						
						addon:SA_Sound(SAMod.Sound.RuptureAlert);						
						SA_Data.BARS[SC_SPELL_RUP]["Expires"] = 0;
						SA_Data.BARS[SC_SPELL_RUP]["obj"]:Hide();
					else
						 local name, rank, icon, count, debuffType, duration, expirationTime = UnitDebuff("target", SC_SPELL_RUP, nil, "PLAYER");						
						 SA_Data.BARS[SC_SPELL_RUP]["Expires"] = addon:CalcExpireTime(expirationTime);
						 SA_Data.BARS[SC_SPELL_RUP]["obj"]:Show();
					end
					addon:SA_ChangeAnchor();
				end
				-- Internal Bleeding EVENT --
				if (isMySpell and spellId == SC_SPELL_INTERNAL_ID and SAMod.ShowTimer.InternalBleeding) then			
					if (type == "SPELL_AURA_REMOVED") then												
						SA_Data.BARS[SC_SPELL_INTERNAL]["Expires"] = 0;
						SA_Data.BARS[SC_SPELL_INTERNAL]["obj"]:Hide();
					else
						 local name, rank, icon, count, debuffType, duration, expirationTime = UnitDebuff("target", SC_SPELL_INTERNAL, nil, "PLAYER");						
						 SA_Data.BARS[SC_SPELL_INTERNAL]["Expires"] = addon:CalcExpireTime(expirationTime);
						 SA_Data.BARS[SC_SPELL_INTERNAL]["obj"]:Show();
					end
					addon:SA_ChangeAnchor();
				end
				-- GARROTE EVENT --
				if (isMySpell and spellId == SC_SPELL_GARROTE_ID and SAMod.ShowTimer.Garrote) then			
					if (type == "SPELL_AURA_REMOVED") then																	
						SA_Data.BARS[SC_SPELL_GARROTE]["Expires"] = 0;
						SA_Data.BARS[SC_SPELL_GARROTE]["obj"]:Hide();
					else
						 local name, rank, icon, count, debuffType, duration, expirationTime = UnitDebuff("target", SC_SPELL_GARROTE, nil, "PLAYER");						
						 SA_Data.BARS[SC_SPELL_GARROTE]["Expires"] = addon:CalcExpireTime(expirationTime);
						 SA_Data.BARS[SC_SPELL_GARROTE]["obj"]:Show();
					end
					addon:SA_ChangeAnchor();
				end
				-- HagTest REVEALING STRIKE EVENT --
				if (isMySpell and spellId == SC_SPELL_REVEAL_ID and SAMod.ShowTimer.RevealingStrike) then			
					if (type == "SPELL_AURA_REMOVED") then
						 addon:SA_Sound(SAMod.Sound.RevealingStrikeAlert);						  
						 SA_Data.BARS[SC_SPELL_REVEAL]["Expires"] = 0;
						 SA_Data.BARS[SC_SPELL_REVEAL]["obj"]:Hide();
					else
						 local name, rank, icon, count, debuffType, duration, expirationTime = UnitDebuff("target", SC_SPELL_REVEAL, nil, "PLAYER");
						 SA_Data.BARS[SC_SPELL_REVEAL]["Expires"] = addon:CalcExpireTime(expirationTime);
						 SA_Data.BARS[SC_SPELL_REVEAL]["obj"]:Show();
					end
					addon:SA_ChangeAnchor();
				end
				-- Hemorrhage --
				if (isMySpell and spellId == SC_SPELL_HEMO_ID and SAMod.ShowTimer.Hemorrhage) then			
					if (type == "SPELL_AURA_REMOVED") then
						 SA_Data.BARS[SC_SPELL_HEMO]["Expires"] = 0;
						 SA_Data.BARS[SC_SPELL_HEMO]["obj"]:Hide();
					else
						 local name, rank, icon, count, debuffType, duration, expirationTime = UnitDebuff("target", SC_SPELL_HEMO, nil, "PLAYER");
						 SA_Data.BARS[SC_SPELL_HEMO]["Expires"] = addon:CalcExpireTime(expirationTime);
						 SA_Data.BARS[SC_SPELL_HEMO]["obj"]:Show();
					end
					addon:SA_ChangeAnchor();
				end
				-- VENDETTA EVENT --
				if (isMySpell and spellId == SC_SPELL_VEND_ID and SAMod.ShowTimer.Vendetta) then
					if (type == "SPELL_AURA_REMOVED") then						
						addon:SA_Sound(SAMod.Sound.VendettaAlert);										
						SA_Data.BARS[SC_SPELL_VEND]["Expires"] = 0;
						SA_Data.BARS[SC_SPELL_VEND]["obj"]:Hide();
					else
						local name, rank, icon, coun, debuffType, duration, expirationTime = UnitDebuff("target", SC_SPELL_VEND, nil, "PLAYER");						
						SA_Data.BARS[SC_SPELL_VEND]["Expires"] = addon:CalcExpireTime(expirationTime);
						SA_Data.BARS[SC_SPELL_VEND]["obj"]:Show();
					end
					addon:SA_ChangeAnchor();
				end
				-- FIND WEAKNESS EVENT --
				if (isMySpell and spellId == SC_SPELL_FW_ID and SAMod.ShowTimer.FindWeaknes) then
					if (type == "SPELL_AURA_REMOVED") then						
						addon:SA_Sound(SAMod.Sound.FindWeaknesAlert);										
						SA_Data.BARS[SC_SPELL_FW]["Expires"] = 0;
						SA_Data.BARS[SC_SPELL_FW]["obj"]:Hide();
					else
						local name, rank, icon, coun, debuffType, duration, expirationTime = UnitDebuff("target", SC_SPELL_FW, nil, "PLAYER");						
						SA_Data.BARS[SC_SPELL_FW]["Expires"] = addon:CalcExpireTime(expirationTime);
						SA_Data.BARS[SC_SPELL_FW]["obj"]:Show();
					end
					addon:SA_ChangeAnchor();
				end
			end
		end
	end -- "SPELL_AURA_REFRESH" or ...
	-- DOT monitors
	if (SAMod.ShowTimer.Options.ShowDoTDmg and type == "SPELL_PERIODIC_DAMAGE" and destName == GetUnitName("target",true) and sourceName == UnitName("player")) then
		local spellId, spellName, spellSchool = select(12, ...); 
		if (spellId == SC_SPELL_RUP_ID and SAMod.ShowTimer.Rupture) then
			local amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(15, ...)
			SA_Data.BARS[SC_SPELL_RUP]["obj"].DoTtext:SetAlpha(1);
			if (SAMod.ShowTimer.Options.DoTCrits and critical) then
				SA_Data.BARS[SC_SPELL_RUP]["obj"].DoTtext:SetText(string.format("*%.0f*", amount));
				UIFrameFadeOut(SA_Data.BARS[SC_SPELL_RUP]["obj"].DoTtext, 3, 1, 0);
			else
				SA_Data.BARS[SC_SPELL_RUP]["obj"].DoTtext:SetText(amount);
				UIFrameFadeOut(SA_Data.BARS[SC_SPELL_RUP]["obj"].DoTtext, 2, 1, 0);
			end
		end
		if (spellId == SC_SPELL_INTERNAL_ID and SAMod.ShowTimer.InternalBleeding) then
			local amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(15, ...)
			SA_Data.BARS[SC_SPELL_INTERNAL]["obj"].DoTtext:SetAlpha(1);
			if (SAMod.ShowTimer.Options.DoTCrits and critical) then
				SA_Data.BARS[SC_SPELL_INTERNAL]["obj"].DoTtext:SetText(string.format("*%.0f*", amount));
				UIFrameFadeOut(SA_Data.BARS[SC_SPELL_INTERNAL]["obj"].DoTtext, 3, 1, 0);
			else
				SA_Data.BARS[SC_SPELL_INTERNAL]["obj"].DoTtext:SetText(amount);
				UIFrameFadeOut(SA_Data.BARS[SC_SPELL_INTERNAL]["obj"].DoTtext, 2, 1, 0);
			end
		end
		if (spellId == SC_SPELL_DP_ID and SAMod.ShowTimer.DeadlyPoison) then
			local amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(15, ...)
			SA_Data.BARS[SC_SPELL_DP]["obj"].DoTtext:SetAlpha(1);
			if (SAMod.ShowTimer.Options.DoTCrits and critical) then
				SA_Data.BARS[SC_SPELL_DP]["obj"].DoTtext:SetText(string.format("*%.0f*", amount));
				UIFrameFadeOut(SA_Data.BARS[SC_SPELL_DP]["obj"].DoTtext, 3, 1, 0);
			else
				SA_Data.BARS[SC_SPELL_DP]["obj"].DoTtext:SetText(amount);
				UIFrameFadeOut(SA_Data.BARS[SC_SPELL_DP]["obj"].DoTtext, 2, 1, 0);
			end
		end
		if (spellId == SC_SPELL_GARROTE_ID and SAMod.ShowTimer.Garrote) then
			local amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(15, ...)
			SA_Data.BARS[SC_SPELL_GARROTE]["obj"].DoTtext:SetAlpha(1);
			if (SAMod.ShowTimer.Options.DoTCrits and critical) then
				SA_Data.BARS[SC_SPELL_GARROTE]["obj"].DoTtext:SetText(string.format("*%.0f*", amount));
				UIFrameFadeOut(SA_Data.BARS[SC_SPELL_GARROTE]["obj"].DoTtext, 3, 1, 0);
			else
				SA_Data.BARS[SC_SPELL_GARROTE]["obj"].DoTtext:SetText(amount);
				UIFrameFadeOut(SA_Data.BARS[SC_SPELL_GARROTE]["obj"].DoTtext, 2, 1, 0);
			end
		end
	end
end

function addon:SA_TestTarget() 
	if SAMod.ShowTimer.DeadlyPoison then
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster = UnitDebuff("target", SC_SPELL_DP, nil, "PLAYER");
		if not name then		
			SA_Data.BARS[SC_SPELL_DP]["Expires"] = 0;
			SA_Data.BARS[SC_SPELL_DP]["obj"]:Hide();
		else
			if (unitCaster == "player") then			
				SA_Data.BARS[SC_SPELL_DP]["Expires"] = addon:CalcExpireTime(expirationTime);		
				SA_Data.BARS[SC_SPELL_DP]["obj"]:Show();
			else			
				SA_Data.BARS[SC_SPELL_DP]["Expires"] = 0;
				SA_Data.BARS[SC_SPELL_DP]["obj"]:Hide();
			end
		end
	end
	if SAMod.ShowTimer.Rupture then
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster = UnitDebuff("target", SC_SPELL_RUP, nil, "PLAYER");
		if not name then		 
			SA_Data.BARS[SC_SPELL_RUP]["Expires"] = 0;
			SA_Data.BARS[SC_SPELL_RUP]["obj"]:Hide();
		else
			if (unitCaster == "player") then			
				SA_Data.BARS[SC_SPELL_RUP]["Expires"] = addon:CalcExpireTime(expirationTime);
				SA_Data.BARS[SC_SPELL_RUP]["obj"]:Show();
			else			
				SA_Data.BARS[SC_SPELL_RUP]["Expires"] = 0;
				SA_Data.BARS[SC_SPELL_RUP]["obj"]:Hide();		
			end
		 end	
	end
	if SAMod.ShowTimer.InternalBleeding then
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster = UnitDebuff("target", SC_SPELL_INTERNAL, nil, "PLAYER");
		if not name then		 
			SA_Data.BARS[SC_SPELL_INTERNAL]["Expires"] = 0;
			SA_Data.BARS[SC_SPELL_INTERNAL]["obj"]:Hide();
		else
			if (unitCaster == "player") then			
				SA_Data.BARS[SC_SPELL_INTERNAL]["Expires"] = addon:CalcExpireTime(expirationTime);
				SA_Data.BARS[SC_SPELL_INTERNAL]["obj"]:Show();
			else			
				SA_Data.BARS[SC_SPELL_INTERNAL]["Expires"] = 0;
				SA_Data.BARS[SC_SPELL_INTERNAL]["obj"]:Hide();		
			end
		 end	
	end
	if SAMod.ShowTimer.Garrote then
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster = UnitDebuff("target", SC_SPELL_GARROTE, nil, "PLAYER");
		if not name then		 
			SA_Data.BARS[SC_SPELL_GARROTE]["Expires"] = 0;
			SA_Data.BARS[SC_SPELL_GARROTE]["obj"]:Hide();
		else
			if (unitCaster == "player") then			
				SA_Data.BARS[SC_SPELL_GARROTE]["Expires"] = addon:CalcExpireTime(expirationTime);
				SA_Data.BARS[SC_SPELL_GARROTE]["obj"]:Show();
			else			
				SA_Data.BARS[SC_SPELL_GARROTE]["Expires"] = 0;
				SA_Data.BARS[SC_SPELL_GARROTE]["obj"]:Hide();		
			end
		 end	
	end
	if SAMod.ShowTimer.RevealingStrike then
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster = UnitDebuff("target", SC_SPELL_REVEAL, nil, "PLAYER");
		if not name then		 
			SA_Data.BARS[SC_SPELL_REVEAL]["Expires"] = 0;
			SA_Data.BARS[SC_SPELL_REVEAL]["obj"]:Hide();
		else
			if (unitCaster == "player") then			
				SA_Data.BARS[SC_SPELL_REVEAL]["Expires"] = addon:CalcExpireTime(expirationTime);
				SA_Data.BARS[SC_SPELL_REVEAL]["obj"]:Show();
			else			
				SA_Data.BARS[SC_SPELL_REVEAL]["Expires"] = 0;
				SA_Data.BARS[SC_SPELL_REVEAL]["obj"]:Hide();
			end
		 end	
	end
	if SAMod.ShowTimer.Vendetta then
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster = UnitDebuff("target", SC_SPELL_VEND, nil, "PLAYER");
		 if not name then		
			SA_Data.BARS[SC_SPELL_VEND]["Expires"] = 0;
			SA_Data.BARS[SC_SPELL_VEND]["obj"]:Hide();
		else
			if (unitCaster == "player") then			
				SA_Data.BARS[SC_SPELL_VEND]["Expires"] = addon:CalcExpireTime(expirationTime);
				SA_Data.BARS[SC_SPELL_VEND]["obj"]:Show();
			else			
				SA_Data.BARS[SC_SPELL_VEND]["Expires"] = 0;
				SA_Data.BARS[SC_SPELL_VEND]["obj"]:Hide();
			end
		end	
	end
	if SAMod.ShowTimer.FindWeaknes then
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster = UnitDebuff("target", SC_SPELL_FW, nil, "PLAYER");
		if not name then		
			SA_Data.BARS[SC_SPELL_FW]["Expires"] = 0;
			SA_Data.BARS[SC_SPELL_FW]["obj"]:Hide();
		else
			if (unitCaster == "player") then			
				SA_Data.BARS[SC_SPELL_FW]["Expires"] = addon:CalcExpireTime(expirationTime);
				SA_Data.BARS[SC_SPELL_FW]["obj"]:Show();
			else			
				SA_Data.BARS[SC_SPELL_FW]["Expires"] = 0;
				SA_Data.BARS[SC_SPELL_FW]["obj"]:Hide();
			end
		end	
	end 
	if SAMod.ShowTimer.Hemorrhage then
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster = UnitDebuff("target", SC_SPELL_HEMO, nil, "PLAYER");
		if not name then		
			SA_Data.BARS[SC_SPELL_HEMO]["Expires"] = 0;
			SA_Data.BARS[SC_SPELL_HEMO]["obj"]:Hide();
		else
			if (unitCaster == "player") then			
				SA_Data.BARS[SC_SPELL_HEMO]["Expires"] = addon:CalcExpireTime(expirationTime);
				SA_Data.BARS[SC_SPELL_HEMO]["obj"]:Show();
			else			
				SA_Data.BARS[SC_SPELL_HEMO]["Expires"] = 0;
				SA_Data.BARS[SC_SPELL_HEMO]["obj"]:Hide();
			end
		end	
	end
	addon:SA_ChangeAnchor(); 
end
local curCombo = 0
function addon:SA_SetComboPts() 
	local points = GetComboPoints("player");
	local name, rank, icon, count = UnitAura("player", SC_SPELL_ANTICI)	
	count = count or 0	
	local text = "0(0)"
	if count > 0 and SAMod.Combo.AnticipationShow then
		text = points .. "(" .. count.. ")"
	else
		text = points
	end
	if SAMod.Energy.ShowComboText then
		if (points == 0 and count == 0) then
			SA_Combo:SetText("");
		else
			SA_Combo:SetText(text);
		end			
	end
	if SAMod.Combo.PointShow then	
		if name and (count > 0) and SAMod.Combo.AnticipationShow then
			for i = 1, count do
				SA_Data.BARS["CP"]["obj"].antis[i]:Show();
			end	 
		else
			for i = 1, 5 do
				SA_Data.BARS["CP"]["obj"].antis[i]:Hide();
			end
		end 
		if (points > curCombo) then
			for i = curCombo + 1, points do
				SA_Data.BARS["CP"]["obj"].combos[i]:Show();
			end			
		else
			for i = points + 1, curCombo do
				SA_Data.BARS["CP"]["obj"].combos[i]:Hide();
			end						
		 end 
		curCombo = points; 			
	end
end

function addon:SA_CPFrame()
	 local f = CreateFrame("Frame", nil, SA);
	 local width = widthUI --SA_Data.BARS["CP"]["obj"]:GetWidth();

	 f:ClearAllPoints();
	 f:SetWidth(width);
	 f:SetScale(scaleUI);
	 f:SetHeight(10); 
	 f:SetAllPoints(VTimerEnergy)
	 --f:SetPoint("TOPLEFT", VTimerEnergy, "BOTTOMLEFT", 1, 0);
	 
	 
	 f.bg = f:CreateTexture(nil, "BACKGROUND");
	 f.bg:ClearAllPoints();
	 --f.bg:SetAllPoints(f);
	 f.bg:SetPoint("TOPLEFT", f, "TOPLEFT", -1, 1);
	 f.bg:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 1, -2);
	 f.bg:SetTexture(addon:SA_BarTexture("stats"));
	 f.bg:SetVertexColor(0.3, 0.3, 0.3);
	 f.bg:SetAlpha(0.7);

	 f.combos = {};
	 f.antis = {};

	 local cx = 0;
	 local spacing = width/30; --orig:= 3
	 local cpwidth = ((width-(spacing*4))/9.2);

	 -- text
	 local font = "Fonts\\FRIZQT__.TTF";
	 local fontsize = 12;
	 local fontstyle = "OUTLINE";
	 local cpC = SAMod.Combo.CPColor
	 local cpA = SAMod.Combo.AnColor

	 for i = 1, 5 do
		local combo = CreateFrame("Frame", nil, f);	
		combo:ClearAllPoints()
		combo:SetPoint("TOPLEFT", f, "TOPLEFT", cx, 0)
		combo:SetPoint("BOTTOMRIGHT", f, "BOTTOMLEFT", cx + cpwidth, 0)

		combo:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
			 edgeFile = "Interface/Tooltips/UI-Tooltip-Border", --"Interface/Tooltips/UI-Tooltip-Border"
			 tile = true, tileSize = 8, edgeSize = 8,
			 insets = { left = 2, right = 2, top = 2, bottom = 2 }});
		combo:SetBackdropColor( cpC.r, cpC.g, cpC.b);

		combo.bg = combo:CreateTexture(nil, "BACKGROUND") 
		combo:Hide()	
		f.combos[i] = combo;	
		
		cx = cx + cpwidth + spacing
	 end
	 cx = 0;	 
	 for i = 1, 5 do
		local anti = CreateFrame("Frame", nil, f);
		anti:SetFrameLevel(14); -- Better than f.combo[i] as parrent due to visibility
		anti:ClearAllPoints()
		anti:SetPoint("TOPLEFT", f, "TOPLEFT", cx, 0)
		anti:SetPoint("BOTTOMRIGHT", f, "BOTTOMLEFT", cx + cpwidth, 0)

		anti:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
			 edgeFile = "Interface/DialogFrame/UI-DialogBox-Gold-Border", --"Interface/Tooltips/UI-Tooltip-Border"
			 tile = true, tileSize = 8, edgeSize = 8,
			 insets = { left = 2, right = 2, top = 2, bottom = 2 }});
		anti:SetBackdropColor( cpA.r, cpA.g, cpA.b);

		anti.bg = anti:CreateTexture(nil, "BACKGROUND") 
		anti:Hide()	 
		f.antis[i] = anti;
		
		cx = cx + cpwidth + spacing
	 end

	 --f.overlay = CreateFrame("Frame", nil, f)
	 --f.overlay:ClearAllPoints()
	 --f.overlay:SetAllPoints(f)
	 f:Hide();
	 return f;
end

function addon:SA_UpdateCPWidths()
	local width = VTimerEnergy:GetWidth()
	local cx = 0;
	local spacing = width/30; --orig:= 3
	local cpwidth = ((width-(spacing*4))/5); --orig: ((width-(spacing*4))/5);

	local f = SA_Data.BARS["CP"]["obj"]

	for i = 1, 5 do
		local combo = SA_Data.BARS["CP"]["obj"].combos[i]
		local anti = SA_Data.BARS["CP"]["obj"].antis[i]
		combo:ClearAllPoints()	
		anti:ClearAllPoints()
		combo:SetPoint("TOPLEFT", f, "TOPLEFT", cx, 0)
		anti:SetPoint("TOPLEFT", f, "TOPLEFT", cx, 0)
		combo:SetPoint("BOTTOMRIGHT", f, "BOTTOMLEFT", cx + cpwidth, 0)
		anti:SetPoint("BOTTOMRIGHT", f, "BOTTOMLEFT", cx + cpwidth, 0)

		cx = cx + cpwidth + spacing
	end
end

function addon:SA_UpdateStatWidths()
 local width = VTimerEnergy:GetWidth()

 local numStats = SA2.numStats or 3--HP TODO option for this
 local spacing = width/90;
 local cpwidth = ((width-(spacing*3))/(numStats));
 local cur_location = 0; --small initial offset

 local f = SA_Data.BARS["Stat"]["obj"];

 for i = 1, 4 do
	--Create the frame & space it
	local statText = SA_Data.BARS["Stat"]["obj"].stats[i];
	local labelFrame = SA_Data.BARS["Stat"]["obj"].stats[i].labelFrame;
	statText:ClearAllPoints();
	statText:SetPoint("TOPLEFT", f, "TOPLEFT", cur_location, 0)
	statText:SetPoint("BOTTOMRIGHT", f, "BOTTOMLEFT", cur_location + cpwidth, 0)

	labelFrame:ClearAllPoints();
	labelFrame:SetPoint("TOPLEFT", f, "TOPLEFT", cur_location, 0)
	labelFrame:SetPoint("BOTTOMRIGHT", f, "BOTTOMLEFT", cur_location + cpwidth, 0)

	cur_location = cur_location + cpwidth + spacing;
	statText:Show()
	labelFrame:Show()
	if numStats < i then
	  statText:Hide()
	  labelFrame:Hide()
	end
 end
end

function addon:SA_CreateStatBar()
	local f = CreateFrame("StatusBar", nil, SA);
	local width = widthUI;

	f:ClearAllPoints();
	f:SetWidth(width);
	f:SetScale(scaleUI);
	f:SetHeight(15)
	f:SetPoint("BOTTOMLEFT", VTimerEnergy, "TOPLEFT", 0, 1) 

	f.bg = f:CreateTexture(nil, "BACKGROUND")
	f.bg:ClearAllPoints() 
	f.bg:SetPoint("TOPLEFT", f, "TOPLEFT", -1, 1)
	f.bg:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 1, -1)
	f.bg:SetTexture(addon:SA_BarTexture("stats"))
	f.bg:SetVertexColor(0.3, 0.3, 0.3)
	f.bg:SetAlpha(0.7)

	f.stats = {}

	local numStats = SA2.numStats or 4; --HP TODO option for this
	local spacing = width/60;
	local cpwidth = ((width-(spacing*3))/(numStats));
	local cur_location = 1; --small initial offset

	-- text
	local font = "Fonts\\FRIZQT__.TTF"
	local fontsize = 9
	if (numStats > 3) then
		fontsize = 8;
	end

	local fontstyle = "OUTLINE"
	local lableText = {[1] = "AP",
						[2] = "Crit",
						[3] = "Speed",
						[4] = "Armor" }
	 
	for i = 1, 4 do	
		--Create the frame & space it
		local statText = CreateFrame("Frame", nil, f)
		statText:ClearAllPoints() 
		statText:SetPoint("TOPLEFT", f, "TOPLEFT", cur_location, 0)
		statText:SetPoint("BOTTOMRIGHT", f, "BOTTOMLEFT", cur_location + cpwidth, 0)
		--Create stat FontString
		statText.fs = statText:CreateFontString("$parentText","ARTWORK","GameFontNormal");
		statText.fs:SetJustifyH("CENTER")
		statText.fs:SetJustifyV("TOP")
		statText.fs:SetFont(font, fontsize, fontstyle);
		statText.fs:SetAllPoints();
		statText.fs:SetText("");

		--Create stat label frame
		local labelFrame = CreateFrame("Frame", nil, f)	
		labelFrame:ClearAllPoints()
		labelFrame:SetPoint("TOPLEFT", f, "TOPLEFT", cur_location, 0) 
		----Create stat label FontString
		labelFrame.fs = labelFrame:CreateFontString("$parentText","ARTWORK","GameFontNormal");
		labelFrame.fs:SetJustifyH("CENTER")
		labelFrame.fs:SetJustifyV("BOTTOM")
		labelFrame.fs:SetFont(font, fontsize/1.6, "");
		labelFrame.fs:SetText(lableText[i]);
		labelFrame.fs:SetAllPoints(); 

		f.stats[i] = statText;
		f.stats[i].labelFrame = labelFrame;

		cur_location = cur_location + cpwidth + spacing;
	end

	return f;
end

function addon:SA_UpdateStats()
	local baseAP, buffAP, negAP = UnitAttackPower("player");
	local totalAP = baseAP+buffAP+negAP;
	local crit = GetCritChance();
	local mhSpeed, ohSpeed = UnitAttackSpeed("player");
	 --local name, _, icon, count = UnitAura("target")--, SC_SPELL_WEAKEN, nil, "HARMFUL");
	local armor = (count or 0)*4; 

	if (SA_Data.BARS["Stat"]["obj"].stats[1]) then
		local text = totalAP
		if(totalAP > 99999) then text = string.format("%.1f", totalAP/1000).."k" end
		SA_Data.BARS["Stat"]["obj"].stats[1].fs:SetText(text);
	end
	if (SA_Data.BARS["Stat"]["obj"].stats[2]) then
		SA_Data.BARS["Stat"]["obj"].stats[2].fs:SetText(string.format("%.1f%%", crit));
	end
	if (SA_Data.BARS["Stat"]["obj"].stats[3]) then
		SA_Data.BARS["Stat"]["obj"].stats[3].fs:SetText(string.format("%.2f", mhSpeed));
	end
	 --[[if (SA_Data.BARS["Stat"]["obj"].stats[4]) then
		SA_Data.BARS["Stat"]["obj"].stats[4].fs:SetText(string.format("%i%%", armor));
	 end ]]
		
	if SAMod.Combo.HilightBuffed then
		addon:SA_flashBuffedStats(totalAP,buffAP,crit,mhSpeed,armor)
	end
end

function addon:SA_flashBuffedStats(totalAP,buffAP,crit,mhSpeed,armor) 
	local numStats = SA2.numStats or 3;
	if (not SA_Data.baseAP or SA_Data.baseAP == 0) then --initialize here since all stats = 0 when OnLoad is called.
		addon:SA_ResetBaseStats();
		return
	end

	local statCheck = {};
	statCheck[1] = ( totalAP > (totalAP - buffAP));
	statCheck[2] = (crit > (SA_Data.baseCrit * 1.5)) ;
	statCheck[3] = (mhSpeed < (SA_Data.baseSpeed / 2));
	statCheck[4] = (armor == 0 and UnitExists("target"));
	 
	for i = 1, numStats do
		if statCheck[i] then
		SA_Data.BARS["Stat"]["obj"].stats[i].fs:SetTextColor(140/255, 15/255, 0);
			if (not UIFrameIsFading(SA_Data.BARS["Stat"]["obj"].stats[i])) then --flash if not already flashing
				if (SA_Data.BARS["Stat"]["obj"].stats[i]:GetAlpha() > 0.5) then
					UIFrameFadeOut(SA_Data.BARS["Stat"]["obj"].stats[i], 1, SA_Data.BARS["Stat"]["obj"].stats[i]:GetAlpha(), 0.1)
				else --UIFrameFlash likes to throw execeptions deep in the bliz ui?
					UIFrameFadeOut(SA_Data.BARS["Stat"]["obj"].stats[i], 1, SA_Data.BARS["Stat"]["obj"].stats[i]:GetAlpha(), 1)
				end
			end
		else
			SA_Data.BARS["Stat"]["obj"].stats[i].fs:SetTextColor(1, .82, 0); --default text color
			UIFrameFadeOut(SA_Data.BARS["Stat"]["obj"].stats[i], 1, SA_Data.BARS["Stat"]["obj"].stats[i]:GetAlpha(), 1) --SA_Data.BARS["Stat"]["obj"].stats[i]:SetAlpha(1);
		end
	end
end

function addon:SA_Unload()
	addon:UnregisterAllEvents();
	SA:Hide();
	DisableAddOn("SliceAdmiral");
end

function addon:SA_NewFrame()
	 local f = CreateFrame("StatusBar", nil, SA);

	 f:SetWidth(widthUI);
	 f:SetScale(scaleUI);
	 f:SetHeight(12);
	 
	 f:SetPoint("BOTTOMLEFT", VTimerEnergy, "TOPLEFT", 2, 0);
	 
	 f:SetStatusBarTexture(addon:SA_BarTexture());
	 f:SetStatusBarColor(0.768627451, 0, 0, 1);
	 f:EnableMouse(false);
	 f:SetMinMaxValues(0, 6.0);
	 f:SetValue(0);

	 f:Hide();

	 f:SetBackdrop({
			 bgFile="Interface\\AddOns\\SliceAdmiral\\Images\\winco_stripe_128.tga",
			 edgeFile="",
			 tile=true, tileSize=1, edgeSize=0,
			 insets={left=-1, right=-1, top=-1, bottom=-3}
		 });
	 f:SetBackdropBorderColor(1,1,1,1);
	 f:SetBackdropColor(0,0,0,0.5);

	 -- text on the right --
	 if not f.text then
		f.text = f:CreateFontString(nil, nil, "GameFontWhite")
	 end
	 f.text:SetFontObject(SA_Data.BarFont2);
	 f.text:SetHeight(10)
	 f.text:SetWidth(30);
	 f.text:SetPoint("TOPRIGHT", f, "TOPRIGHT", -2, -1);
	 f.text:SetJustifyH("RIGHT") 
	 f.text:SetText("");

	 -- icon on the left --
	 if not f.icon then
		f.icon = f:CreateTexture(nil, "OVERLAY");
	 end
	 f.icon:SetHeight(f:GetHeight());
	 f.icon:SetWidth(f.icon:GetHeight());
	 f.icon:SetPoint("TOPLEFT", f, "TOPLEFT", 0, 0);
	 f.icon:SetBlendMode("ADD");
	 f.icon:SetAlpha(.99);

	 -- text on the left --
	 if not f.text2 then
		f.text2 = f:CreateFontString(nil, nil, nil)
	 end
	 f.text2:SetFontObject(SA_Data.BarFont2);
	 f.text2:SetHeight(10)
	 f.text2:SetWidth(60);
	 f.text2:SetPoint("TOPLEFT", f, "TOPLEFT", f.icon:GetWidth() + SAMod.Main.BarMargin + 1, 0);
	 f.text2:SetJustifyH("LEFT")
	 f.text2:SetText("");

	 -- DoT Text --
	 if not f.DoTtext then
		f.DoTtext = f:CreateFontString(nil, nil, nil)
	 end
	 f.DoTtext:SetFontObject(SA_Data.BarFont2);
	 f.DoTtext:SetHeight(10)
	 f.DoTtext:SetWidth(60);
	 f.DoTtext:SetPoint("CENTER", f, "CENTER", 0 , 0);
	 f.DoTtext:SetJustifyH("CENTER")
	 f.DoTtext:SetText("");

	 return f;

end

function addon:SA_ResetBaseStats()
	local baseAP, buffAP, negAP = UnitAttackPower("player");
	local crit = GetCritChance();
	local mhSpeed, ohSpeed = UnitAttackSpeed("player");

	SA_Data.baseAP = baseAP+buffAP;
	SA_Data.baseCrit = crit;
	SA_Data.baseSpeed = mhSpeed; 
end

function addon:SA_OnLoad()
	local localizedClass, englishClass = UnitClass("player");
	if (englishClass == "ROGUE") then
		addon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		addon:RegisterEvent("UNIT_COMBO_POINTS");
		addon:RegisterEvent("PLAYER_ENTERING_WORLD")
		addon:RegisterEvent("PLAYER_REGEN_ENABLED")
		addon:RegisterEvent("PLAYER_REGEN_DISABLED")
		addon:RegisterEvent("UNIT_AURA")
		addon:RegisterEvent("PLAYER_TARGET_CHANGED")		
		SA_Data.BarFont = CreateFont("VTimerFont");
		SA_Data.BarFont:SetFont("Fonts\\FRIZQT__.TTF", 12);
		SA_Data.BarFont:SetShadowColor(0,0,0, 0.7);
		SA_Data.BarFont:SetTextColor(1,1,1,0.9);
		SA_Data.BarFont:SetShadowOffset(0.8, -0.8);

		SA_Data.BarFont2 = CreateFont("VTimerFont2");
		SA_Data.BarFont2:SetFont("Fonts\\FRIZQT__.TTF", 8)
		SA_Data.BarFont2:SetShadowColor(0,0,0, 0.7);
		SA_Data.BarFont2:SetTextColor(1,1,1,0.9);
		SA_Data.BarFont2:SetShadowOffset(0.8, -0.8);

		SA_Data.BarFont3 = CreateFont("VTimerFont1O");
		SA_Data.BarFont3:SetFont("Fonts\\FRIZQT__.TTF", 12);
		SA_Data.BarFont3:SetShadowColor(0,0,0, 1);
		SA_Data.BarFont3:SetTextColor(1,1,1,0.8);
		SA_Data.BarFont3:SetShadowOffset(0.8, -0.8);

		SA_Data.BarFont4 = CreateFont("VTimerFont4");
		SA_Data.BarFont4:SetFont("Fonts\\FRIZQT__.TTF", 8)
		SA_Data.BarFont4:SetShadowColor(0,0,0, 0.7); 
		SA_Data.BarFont4:SetShadowOffset(0.8, -0.8);

		VTimerEnergyTxt:SetFontObject(SA_Data.BarFont);
		SA_Combo:SetFontObject(SA_Data.BarFont3);

		VTimerEnergy:SetMinMaxValues(0,UnitManaMax("player"));
		VTimerEnergy:SetBackdrop({
					bgFile="Interface\\AddOns\\SliceAdmiral\\Images\\winco_stripe_128.tga",
					edgeFile="",
					tile=true, tileSize=1, edgeSize=0,
					insets={left=-1, right=-1, top=-1, bottom=0}
					});
		 
		VTimerEnergy:SetBackdropBorderColor(1,1,1,1);
		VTimerEnergy:SetBackdropColor(0,0,0,0.2);
		VTimerEnergy:SetStatusBarTexture(addon:SA_BarTexture("Energy"));
		VTimerEnergy:SetWidth(200);
		local oEner = SAMod.Energy.Color
		VTimerEnergy:SetStatusBarColor(oEner.r, oEner.g, oEner.b); 

		scaleUI = VTimerEnergy:GetScale();
		widthUI = VTimerEnergy:GetWidth();
		
		S:SmoothBar(VTimerEnergy);
		
		SA_Data.BARS["CP"]["obj"] = addon:SA_CPFrame();

		SA_Data.BARS["Stat"]["obj"] = addon:SA_CreateStatBar();

		SA_Data.BARS[SC_SPELL_SND]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_SND]["obj"]:SetStatusBarColor(255/255, 74/255, 18/255, 0.9);
		SA_Data.BARS[SC_SPELL_SND]["obj"].icon:SetTexture("Interface\\Icons\\Ability_Rogue_SliceDice");

		SA_Data.BARS[SC_SPELL_RUP]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_RUP]["obj"]:SetStatusBarColor(130/255, 15/255, 0);
		SA_Data.BARS[SC_SPELL_RUP]["obj"].text2:SetFontObject(SA_Data.BarFont4);
		SA_Data.BARS[SC_SPELL_RUP]["obj"].icon:SetTexture("Interface\\Icons\\Ability_Rogue_Rupture");
		
		SA_Data.BARS[SC_SPELL_INTERNAL]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_INTERNAL]["obj"]:SetStatusBarColor(205/255, 92/255, 92/255);
		SA_Data.BARS[SC_SPELL_INTERNAL]["obj"].text2:SetFontObject(SA_Data.BarFont4);
		SA_Data.BARS[SC_SPELL_INTERNAL]["obj"].icon:SetTexture("Interface\\Icons\\Ability_Rogue_BloodSplatter");

		SA_Data.BARS[SC_SPELL_VEND]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_VEND]["obj"]:SetStatusBarColor(130/255, 130/255, 0);
		SA_Data.BARS[SC_SPELL_VEND]["obj"].text2:SetFontObject(SA_Data.BarFont4);
		SA_Data.BARS[SC_SPELL_VEND]["obj"].icon:SetTexture("Interface\\Icons\\Ability_Rogue_Deadliness");
		
		SA_Data.BARS[SC_SPELL_FW]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_FW]["obj"]:SetStatusBarColor(130/255, 130/255, 0);
		SA_Data.BARS[SC_SPELL_FW]["obj"].text2:SetFontObject(SA_Data.BarFont4);
		SA_Data.BARS[SC_SPELL_FW]["obj"].icon:SetTexture("Interface\\Icons\\Ability_Rogue_FindWeakness");

		SA_Data.BARS[SC_SPELL_RECUP]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_RECUP]["obj"]:SetStatusBarColor(10/255, 10/255, 150/255);
		SA_Data.BARS[SC_SPELL_RECUP]["obj"].icon:SetTexture("Interface\\Icons\\Ability_Rogue_Recuperate");
		
		SA_Data.BARS[SC_SPELL_GARROTE]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_GARROTE]["obj"]:SetStatusBarColor(130/255, 15/255, 0);
		SA_Data.BARS[SC_SPELL_GARROTE]["obj"].text2:SetFontObject(SA_Data.BarFont4);
		SA_Data.BARS[SC_SPELL_GARROTE]["obj"].icon:SetTexture("Interface\\Icons\\Ability_Rogue_Garrote");
		
		SA_Data.BARS[SC_SPELL_BURST_SPEED]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_BURST_SPEED]["obj"]:SetStatusBarColor(135/255, 135/255, 255/255);
		SA_Data.BARS[SC_SPELL_BURST_SPEED]["obj"]:SetMinMaxValues(0, 4.0);
		SA_Data.BARS[SC_SPELL_BURST_SPEED]["obj"].text2:SetFontObject(SA_Data.BarFont4);
		SA_Data.BARS[SC_SPELL_BURST_SPEED]["obj"].icon:SetTexture("Interface\\Icons\\rogue_burstofspeed");

		SA_Data.BARS[SC_SPELL_DP]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_DP]["obj"]:SetStatusBarColor(96/255, 116/255, 65/255); 
		SA_Data.BARS[SC_SPELL_DP]["obj"].icon:SetTexture("Interface\\Icons\\Ability_Rogue_DualWeild");

		SA_Data.BARS[SC_SPELL_ENV]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_ENV]["obj"]:SetStatusBarColor(66/255, 86/255, 35/255);
		SA_Data.BARS[SC_SPELL_ENV]["obj"].text2:SetFontObject(SA_Data.BarFont4);
		SA_Data.BARS[SC_SPELL_ENV]["obj"].icon:SetTexture("Interface\\Icons\\Ability_Rogue_Disembowel");
		
		SA_Data.BARS[SC_SPELL_FEINT]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_FEINT]["obj"]:SetStatusBarColor(155/255, 155/255, 255/255);
		SA_Data.BARS[SC_SPELL_FEINT]["obj"]:SetMinMaxValues(0, 5.0);
		SA_Data.BARS[SC_SPELL_FEINT]["obj"].text2:SetFontObject(SA_Data.BarFont4);
		SA_Data.BARS[SC_SPELL_FEINT]["obj"].icon:SetTexture("Interface\\Icons\\Ability_Rogue_Feint");
		
		SA_Data.BARS[SC_SPELL_BAND1]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_BAND1]["obj"]:SetStatusBarColor(34/255, 189/255, 34/255); 
		SA_Data.BARS[SC_SPELL_BAND1]["obj"].icon:SetTexture("Interface\\Icons\\Inv_Bijou_Green");
		
		SA_Data.BARS[SC_SPELL_BAND2]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_BAND2]["obj"]:SetStatusBarColor(255/255, 215/255, 0/255); 
		SA_Data.BARS[SC_SPELL_BAND2]["obj"].icon:SetTexture("Interface\\Icons\\Inv_Bijou_Yellow");
		
		SA_Data.BARS[SC_SPELL_BAND3]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_BAND3]["obj"]:SetStatusBarColor(200/255, 34/255, 34/255); 
		SA_Data.BARS[SC_SPELL_BAND3]["obj"].icon:SetTexture("Interface\\Icons\\Inv_Bijou_Red");
		
		SA_Data.BARS[SC_SPELL_REVEAL]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_REVEAL]["obj"]:SetStatusBarColor(139/255, 69/255, 19/255); 
		SA_Data.BARS[SC_SPELL_REVEAL]["obj"].icon:SetTexture("Interface\\Icons\\Inv_Sword_97");
		
		SA_Data.BARS[SC_SPELL_HEMO]["obj"] = addon:SA_NewFrame();
		SA_Data.BARS[SC_SPELL_HEMO]["obj"]:SetStatusBarColor(255/255, 5/255, 5/255); 
		SA_Data.BARS[SC_SPELL_HEMO]["obj"].icon:SetTexture("Interface\\Icons\\Spell_Shadow_Lifedrain");

		SA_Data.BARORDER = {}; -- Initial order puts the longest towards the inside.
		--SA_Data.BARORDER[] = SA_Data.BARS[""]; --Expose Armor 30sec, Anticipation 15sec, Bandits Guile 15 sec, Hemorrhage 24 sec, Feint 5-7 sec.	
		SA_Data.BARORDER[1] = SA_Data.BARS[SC_SPELL_SND]; -- 12-36 sec
		SA_Data.BARORDER[2] = SA_Data.BARS[SC_SPELL_RECUP]; -- 6 - 30 sec
		SA_Data.BARORDER[3] = SA_Data.BARS[SC_SPELL_RUP]; -- 8-24 sec
		SA_Data.BARORDER[4] = SA_Data.BARS[SC_SPELL_VEND]; -- 20 sec
		SA_Data.BARORDER[5] = SA_Data.BARS[SC_SPELL_REVEAL]; -- 18 sec
		SA_Data.BARORDER[6] = SA_Data.BARS[SC_SPELL_HEMO]; -- 24 sec
		SA_Data.BARORDER[7] = SA_Data.BARS[SC_SPELL_FW]; -- 10 sec	
		SA_Data.BARORDER[8] = SA_Data.BARS[SC_SPELL_GARROTE]; -- 18sec
		SA_Data.BARORDER[9] = SA_Data.BARS[SC_SPELL_BURST_SPEED]; --4 sec
		SA_Data.BARORDER[10] = SA_Data.BARS[SC_SPELL_INTERNAL];
		
		print("SliceAdmiral " .. SliceAdmiralVer .. " loaded!! Options are under the SliceAdmiral tab in the Addons Interface menu")
		if (SA) then
			addon:SA_Config_VarsChanged();
			addon:SA_Config_OtherVars();
		end
	 else
		addon:SA_Unload();
		return;
	 end 
end

function addon:CalcExpireTime(expireTime)	 
	if expireTime and (expireTime > 0) and (SA_Data.tNow < expireTime) then 
		return expireTime - SA_Data.tNow;
	else
		return 0;
	end
end

local Sa_filter = {	["player"] = "PLAYER", 
					["target"] = "PLAYER HARMFUL", };
					
function addon:SA_util_Time(unit, spell)
	local _, _, _, _, _, _, expirationTime = UnitAura(unit, spell, nil, Sa_filter[unit]);
	if expirationTime then		
		return addon:CalcExpireTime(expirationTime);
	else		
		return 0;
	end
end

function addon:SA_UpdateBar(unit, spell, sa_sound)
	local sa_time = addon:SA_util_Time(unit, spell);	
	SA_Data.BARS[spell]["Expires"] = sa_time;
	
	if sa_time > 0 then
		if SA_Data.BARS[spell] then
			SA_Data.BARS[spell]["obj"]:SetValue(sa_time);
			SA_Data.BARS[spell]["obj"].text:SetText(string.format("%0.1f", sa_time));
		end
	else
		SA_Data.BARS[spell]["obj"]:Hide();		
		SA_Data.BARS[spell]["Expires"] = 0;
	end	
	if (sa_time <= 3) and (sa_time > 0) then
		if (SA_Data.BARS[spell]["AlertPending"] == 3) then
			SA_Data.BARS[spell]["AlertPending"] = 2;
			addon:SA_Sound(sa_sound);
		else
			if sa_time <= 2 then
				 if (SA_Data.BARS[spell]["AlertPending"] == 2) then		 
					SA_Data.BARS[spell]["AlertPending"] = 1;
					addon:SA_Sound(sa_sound);
				 else
					if sa_time <= 1 then
						 if (SA_Data.BARS[spell]["AlertPending"] == 1) then
							SA_Data.BARS[spell]["AlertPending"] = 0;
							addon:SA_Sound(sa_sound);
						 end
					end
				 end
			end
		 end
	else
		SA_Data.BARS[spell]["AlertPending"] = 3;	 
	end
end

function addon:SA_QuickUpdateBar(unit, spell)
	local sa_time = addon:SA_util_Time(unit, spell);	
	SA_Data.BARS[spell]["Expires"] = sa_time;
	
	if sa_time > 0 then
		if SA_Data.BARS[spell] then
			SA_Data.BARS[spell]["obj"]:SetValue(sa_time);
			SA_Data.BARS[spell]["obj"].text:SetText(string.format("%0.1f", sa_time));
		end
	else
		SA_Data.BARS[spell]["obj"]:Hide();		
		SA_Data.BARS[spell]["Expires"] = 0;
	end	 
end

function addon:OnUpdate(elapsed)
SA_Data.TimeSinceLastUpdate = SA_Data.TimeSinceLastUpdate + elapsed;
if (SA_Data.TimeSinceLastUpdate > SA_Data.UpdateInterval) then	
	if SAMod.Main.PadLatency then
		local down, up, lag = GetNetStats();
		SA_Data.tNow = GetTime() + (lag*2/1000);
	else
		SA_Data.tNow = GetTime();
	end
	if SAMod.Energy.ShowEnergy then
		local lUnitMana = UnitMana("player");
		local lUnitManaMax = UnitManaMax("player");		

		VTimerEnergy:SetValue(lUnitMana);
		VTimerEnergy:SetMinMaxValues(0,lUnitManaMax);

		if (lUnitManaMax == lUnitMana) then
			VTimerEnergyTxt:SetText("");			
		else
			VTimerEnergyTxt:SetText(lUnitMana);			
		end
		if  (lUnitManaMax == lUnitMana) and not (VTimerEnergy:GetAlpha() == SAMod.Energy.EnergyTrans / 100.0) then
			UIFrameFadeOut(VTimerEnergy, 0.4, VTimerEnergy:GetAlpha(), SAMod.Energy.EnergyTrans / 100.0)
		elseif not (lUnitManaMax == lUnitMana) and not (VTimerEnergy:GetAlpha() == 1.0) then
			UIFrameFadeIn(VTimerEnergy, 0.4, VTimerEnergy:GetAlpha(), 1.0);
		end

		addon:SA_Config_OtherVars();
	end
	
	if SAMod.ShowTimer.SliceAndDice then		
		addon:SA_UpdateBar("player",SC_SPELL_SND, SAMod.Sound.SnDTick); 
	end
	if SAMod.ShowTimer.Rupture then
		addon:SA_UpdateBar("target", SC_SPELL_RUP, SAMod.Sound.RuptureTick); 
	end
	if SAMod.ShowTimer.RevealingStrike then
		addon:SA_UpdateBar("target", SC_SPELL_REVEAL, SAMod.Sound.RevealingStrikeTick);	
	end
	if SAMod.ShowTimer.Envenom then 
		addon:SA_QuickUpdateBar("player",SC_SPELL_ENV);
	end
	if SAMod.ShowTimer.Feint then
		addon:SA_QuickUpdateBar("player",SC_SPELL_FEINT);
	end
	if SAMod.ShowTimer.Vendetta then
		addon:SA_UpdateBar("target",SC_SPELL_VEND, SAMod.Sound.VendettaTick); 
	end
	if SAMod.ShowTimer.FindWeaknes then
		addon:SA_UpdateBar("target",SC_SPELL_FW, SAMod.Sound.FindWeaknesTick); 
	end
	if SAMod.ShowTimer.Recuperate then
		addon:SA_UpdateBar("player", SC_SPELL_RECUP, SAMod.Sound.RecuperateTick); 
	end
	if SAMod.ShowTimer.DeadlyPoison then 
		addon:SA_QuickUpdateBar("target",SC_SPELL_DP);
	end
	if SAMod.ShowTimer.BanditsGuile then
		addon:SA_QuickUpdateBar("player",SC_SPELL_BAND1);
		addon:SA_QuickUpdateBar("player",SC_SPELL_BAND2);
		addon:SA_QuickUpdateBar("player",SC_SPELL_BAND3);
	end
	if SAMod.ShowTimer.Hemorrhage then
		addon:SA_QuickUpdateBar("target",SC_SPELL_HEMO);
	end
	if SAMod.ShowTimer.BurstOfSpeed then
		addon:SA_QuickUpdateBar("player",SC_SPELL_BURST_SPEED);
	end
	if SAMod.ShowTimer.Garrote then
		addon:SA_QuickUpdateBar("target",SC_SPELL_GARROTE);
	end
	if SAMod.ShowTimer.InternalBleeding then
		addon:SA_QuickUpdateBar("target",SC_SPELL_INTERNAL);
	end

	-- We need to do this sort here because something could have been
	-- auto refreshed by a proc and we don't get an Update event for that.
	-- But.. only do it once every SA_Data.sortPeriod seconds AND if we have
	-- non-zero timers
	 if SAMod.ShowTimer.Options.SortBars then
		 for i = 1, SA_Data.maxSortableBars do
			 if (SA_Data.BARORDER[i]["Expires"] > 0) then
				addon:MB_SortBarsByTime(i);
				break;
			 end
		 end
	 end

	if SAMod.Combo.ShowStatBar then
		addon:SA_UpdateStats();
	end 
	SA_Data.TimeSinceLastUpdate = 0;
 end
end

function addon:SA_Config_VarsChanged()
	addon:SA_SetScale(SAMod.Main.Scale);
	addon:SA_SetWidth(SAMod.Main.Width);
	local eCo = SAMod.Energy.Color
	local cpC = SAMod.Combo.CPColor
	local cpA = SAMod.Combo.AnColor	
	
	local combos = SA_Data.BARS["CP"]["obj"].combos; 
	local antis = SA_Data.BARS["CP"]["obj"].antis; 
						
	VTimerEnergy:SetStatusBarColor(eCo.r,eCo.g,eCo.b)
	for i = 1,5 do 
		combos[i]:SetBackdropColor(cpC.r,cpC.g,cpC.b); 
		antis[i]:SetBackdropColor(cpA.r,cpA.g,cpA.b)
	end;		
	
	if SAMod.Energy.ShowEnergy then
		VTimerEnergy:Show();		
	else
		VTimerEnergy:Hide();    
	end

	if SAMod.Combo.PointShow then   
		SA_Data.BARS["CP"]["obj"]:Show();		
	else
		SA_Data.BARS["CP"]["obj"]:Hide();     		
	end
	if SAMod.Energy.ShowComboText then
		SA_Combo:Show();			
	else
		SA_Combo:Hide();
	end

	if SAMod.Combo.ShowStatBar then
		SA_Data.BARS["Stat"]["obj"]:Show();
	else
		SA_Data.BARS["Stat"]["obj"]:Hide();
	end

	addon:RetextureBars(addon:SA_BarTexture("spells"),"spells");
	addon:RetextureBars(addon:SA_BarTexture("Energy"),"Energy");
	addon:RetextureBars(addon:SA_BarTexture("stats"),"stats");
	addon:SA_Config_OtherVars();
end

function addon:SA_Config_OtherVars()
	local lUnitManaMax = UnitManaMax("player");
	if (lUnitManaMax == 0) then
		lUnitManaMax = 100
	end
	local p1 = SAMod.Energy.Energy1 / lUnitManaMax * SAMod.Main.Width;
	local p2 = SAMod.Energy.Energy2 / lUnitManaMax * SAMod.Main.Width;

	SA_Spark1:SetPoint("TOPLEFT", VTimerEnergy, "TOPLEFT", p1, 0);
	SA_Spark2:SetPoint("TOPLEFT", VTimerEnergy, "TOPLEFT", p2, 0);
end

function addon:ResetConfig()
	addon.db:ResetProfile(false,true);
	ReloadUI();
end

function addon:OnInitialize()
	addon.db = LibStub("AceDB-3.0"):New("SliceAdmiralDB", SADefaults);
	addon.db.profile.playerName = UnitName("player")
	SAGlobal = addon.db.global
	SA2 = addon.db.profile.data
	SAMod = addon.db.profile.Modules
	addon.opt.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(addon.db);	
	addon.opt.Main.args = {
				version = {name = "SliceAdmiral "..L["Version"]..": "..GetAddOnMetadata("SliceAdmiral", "Version"),order=90,type = "header"},
				lockMovement = {name=L["ClickToMove"],type="toggle",order=1,		
					get = function(info) return SAMod.Main.IsLocked; end,
					set = function(info,val) SAMod.Main.IsLocked = val; SA:EnableMouse(not val); VTimerEnergy:EnableMouse( not val); end
				},
				padLatency = {name=L["PadLatency"],type="toggle",order=3, width="full",		
					get = function(info) return SAMod.Main.PadLatency; end,
					set = function(info,val) SAMod.Main.PadLatency = val; end
				},
				resetPost = {name=L["ResetPossition"], type = "execute", order=2,
					desc = L["ResetPositionDecs"],
					func = function()
						if (InCombatLockdown()) then 
							addon:Print(ERR_NOT_IN_COMBAT);
						else
							SA:ClearAllPoints();SA:SetPoint("TOPLEFT", 100, -150);
						end
					end
				},
				mainInfo = {name = L["Main/info"], type = "description", order=4,width="full", },
				addonScale = {name=L["Main/Scale"],type="range",width="normal",order=11,
					min=50,max=200,step=1,
					get = function(info) return SAMod.Main.Scale; end,
					set = function(info,val) SAMod.Main.Scale = val; addon:SA_SetScale(val); end
				}, 
				barWidth = {name=L["Main/Width"],type="range",width="normal",order=12,				
					min=25,max=300,step=5,
					get = function(info) return SAMod.Main.Width; end,
					set = function(info,val) SAMod.Main.Width = val; addon:SA_SetWidth(val); end
				},
				empty = {name="",type="description",order=13,},
				fade = {name=L["Main/oocFade"],type="range",width="normal",order=14,
					min=0,max=100,step=1,
					get = function(info) return SAMod.Main.Fade; end,
					set = function(info,val) SAMod.Main.Fade = val; SA:SetAlpha(val/100); end
				},
				barTexture = {name=L["Main/Texture"],type="select",order=15,
					values = SA_Text,
					get = function(info) return SAMod.Main.BarTexture; end,
					set = function(info,val) SAMod.Main.BarTexture = val; addon:RetextureBars(val,"stats"); end
				},
				reset = {name = L["ResetDatabase"],type = "execute",order=100,width="full",
					desc = L["ResetDatabaseDesc"],
					func = function()
						if (InCombatLockdown()) then 
							addon:Print(ERR_NOT_IN_COMBAT);
						else
							addon.db:ResetDB();
							ReloadUI();
						end
					end
				},
			}
	
	-- Add dual-spec support
	--local LibDualSpec = LibStub('LibDualSpec-1.0')
	--LibDualSpec:EnhanceDatabase(self.db, "SliceAdmiral")
	--LibDualSpec:EnhanceOptions(addon.opt.profile, self.db)
	-- Spec Setup
	addon.db.RegisterCallback(self, "OnNewProfile", "InitializeProfile")
	addon.db.RegisterCallback(self, "OnProfileChanged", "UpdateModuleConfigs")
	addon.db.RegisterCallback(self, "OnProfileCopied", "UpdateModuleConfigs")
	addon.db.RegisterCallback(self, "OnProfileReset", "UpdateModuleConfigs")
end

function addon:InitializeProfile()	
	self.db:RegisterDefaults(SADefaults)	
end

function addon:UpdateModuleConfigs()
	self.db:RegisterDefaults(SADefaults)	
end

function addon:AddOption(name, Table, displayName)
	AceConfig:RegisterOptionsTable("SliceAdmiral"..name, Table)
	AceConfigDialog:AddToBlizOptions("SliceAdmiral"..name, displayName, "SliceAdmiral")
end

function addon:OnEnable()
	AceConfig:RegisterOptionsTable("SliceAdmiral", addon.opt.Main)
	self.optionsFrame = AceConfigDialog:AddToBlizOptions("SliceAdmiral")	
	if addon:GetModule("ShowTimer", true) then addon:AddOption("ShowTimer Bars", addon.opt.ShowTimer, L["TimerBars"]) end	
    if addon:GetModule("Combo", true) then addon:AddOption("Combo Points", addon.opt.Combo, L["Combo"]) end
    if addon:GetModule("Energy", true) then addon:AddOption("Energy Bar", addon.opt.Energy, L["EnergyBar"]) end    
	--addon:AddOption("Profiles", addon.opt.profile, "Profiles"); --Localization Needed
	local localizedClass, englishClass = UnitClass("player");
	if (englishClass == "ROGUE") then
		addon:SA_OnLoad()
		SA:SetScript("OnUpdate", addon.OnUpdate);
		SA:SetScript("OnMouseDown", function(self) if (not SAMod.Main.IsLocked) then self:StartMoving() end end)
		SA:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end )
		SA:EnableMouse(not SAMod.Main.IsLocked);
		VTimerEnergy:EnableMouse(not SAMod.Main.IsLocked);
		VTimerEnergy:SetScript("OnMouseDown", function(self) if (not SAMod.Main.IsLocked) then SA:StartMoving() end end)
		VTimerEnergy:SetScript("OnMouseUp", function(self) SA:StopMovingOrSizing() end )	
		addon:SA_SetScale(SAMod.Main.Scale)
		addon:SA_SetWidth(SAMod.Main.Width)
	else
		addon:SA_Unload()
	end
end